Dim SalesOrder
Dim Customer
Dim Carrier
Dim Service
Dim HundredWeight
Dim ActualCost
Dim ComputedCost
Dim ComputedCharge
Dim Charge
Dim Cost

'MSGBOX CustomCharge("<CustomCharge><SalesOrder>001595</SalesOrder> <Customer>0000001</Customer> <ActualCost>27.24</ActualCost> </CustomCharge> " )

Function CustomCharge(XmlIn) ' As String
  ' First parse the XML input
  Call ParseXML(XmlIn)

  ' Calculate your custom charge and cost values here

  Charge = ActualCost * 1.1
  Cost = ActualCost * .9

  ' To finish, put the computed charge and cost into the proper XML format
  CustomCharge = FormReturnXML()
End Function


Private Sub ParseXML(XmlIn)
  Set xmlDoc = CreateObject("Msxml2.DOMDocument")
  xmlDoc.async = false
  xmlDoc.loadXML(XmlIn)

  For Each Node In xmlDoc.ChildNodes
    For Each SubNode In Node.ChildNodes
      Select Case SubNode.NodeName
        case "SalesOrder"
          SalesOrder = SubNode.Text
        case "Customer"
          Customer = SubNode.Text
        case "Carrier"
          Carrier = SubNode.Text
        case "Service"
          Service = SubNode.Text
        case "HundredWeight"
          HundredWeight = SubNode.Text
        case "ActualCost"
          ActualCost = CCur(SubNode.Text)
        case "ComputedCost"
          ComputedCost = CCur(SubNode.Text)
        case "ComputedCharge"
          ComputedCharge = CCur(SubNode.Text)
      End Select
    Next
  Next
End Sub

Private Function FormReturnXML()
 FormReturnXML = "<CustomCharge>"
 FormReturnXML = FormReturnXML & "<Charge>" & FormatNumber(Charge,2) & "</Charge>"
 FormReturnXML = FormReturnXML & "<Cost>" & FormatNumber(Cost,2) & "</Cost>"
 FormReturnXML = FormReturnXML & "</CustomCharge>"
End Function
